#include "pichart.h"

#ifdef CLOCK_MONOTONIC_RAW
static struct timespec tic_start;
void tic() {
    clock_gettime(CLOCK_MONOTONIC_RAW,&tic_start);
}
double toc() {
    struct timespec tic_stop;
    clock_gettime(CLOCK_MONOTONIC_RAW,&tic_stop);
    double sec=tic_stop.tv_sec-tic_start.tv_sec;
    return sec+(tic_stop.tv_nsec-tic_start.tv_nsec)*1.0e-9;
}
#else
static struct timeval tic_start;
void tic() {
    gettimeofday(&tic_start,0);
}
double toc() {
    struct timeval tic_stop;
    gettimeofday(&tic_stop,0);
    double sec=tic_stop.tv_sec-tic_start.tv_sec;
    return sec+(tic_stop.tv_usec-tic_start.tv_usec)*1.0e-6;
}
#endif
void *mymalloc(size_t size,char *p){
    void *r=malloc(size);
    if(!r){
        fprintf(stderr,"Error allocating %lu bytes for %s!\n",
            (unsigned long)size,p);
        exit(1);
    }
    return r;
}
